//JavaScript Document
#target photoshop
//app.bringToFront();

if (app.locale == 'de_DE')
 {
	strPresets = "Vorgaben";
	strScripts = "Skripte";
	colbtn6 = 'V';
	colbtn7 = 'H'; 
  }
else
  {
	strPresets = "Presets";
	strScripts = "Scripts";
	colbtn6 = 'F';
	colbtn7 = 'B'; 
  }

if (parseInt(app.version) < 9 )  //Photoshop CS oder 7
      {
	var Defaultsettingsfile = new File( app.path + "/aspectframe_lastsetting.xml");	
	colbtn = 'button';
	colbtn1 = '00';
	colbtn2 = '50';
	colbtn3 = '80';
	colbtn4 = 'C0';
	colbtn5 = 'FF'; 
      }	
      else //CS2 oder höher
      {      
        //in case we double clicked the file
	var Defaultsettingsfile = new File("~/aspectframe_lastsetting.xml");        
	var Filepath =  app.path + '/' + strPresets + '/' + strScripts + '/';
	colbtn = 'iconbutton';
	colbtn1 = Filepath+'black.png'; //'00';
	colbtn2 = Filepath+'grau64.png'; //'50';
	colbtn3 = Filepath+'grau128.png'; //'80';
	colbtn4 = Filepath+'grau192.png'; //'C0';
	colbtn5 = Filepath+'weiss.png'; //'FF'; 
	}	





//Global Values

var strPickXML="Einstellungen wählen ...";
var strPickXMLSave="Einstellungen speichern unter ...";
var strPickXMLWin="XML Dateien: *.xml";


var ratio_type;		//Type of aspect ratio selected, eg. 3:2, 4:3 etc
var frame_type;		//Type of boundary, eg blank or double
var in_width,center_width,out_width,frame_width;		//Frame Width in pixel
var input_folder = Folder('/e/thomas/Input')   //Default Input Folder
var output_folder = Folder('/e/thomas/Output') //Default Output Folder
var direction;		//Direction of the photo, horizontal or vertical
var stroke_width = 1;
var orgheight, orgwidth, corner;
var strokew1=3;
var strokew2=3;
var strokew3=3;
var strTitle = 'aspectframe';
var gversion = '1.0';




//****************************************
//***Part I -- Setup The Input Template***
//****************************************

// enable double clicking from the Macintosh Finder or the Windows Explorer

try
{

	if (documents.length) {

		var originalUnit = preferences.rulerUnits;
		preferences.rulerUnits = Units.PIXELS;
		
		//var org_forecolor = app.foregroundColor;
		//var org_backcolor = app.backgroundColor;
		
	   var gAF = new AspectFrame();
	   
	   gAF.params = 	gAF.InitParams();

	   gAF.LoadParamsFromDisk( Defaultsettingsfile );
	   
	   //alert (gAF.params["aspect_frame_r1"]);
	   
	   MakeFrameAroundPhoto(app.activeDocument,gAF.params);

	   /* Kein Dialog sondern letzte Einstellungen ... 
	   gAF.CreateDialog();

	   if ( gAF.RunDialog() ) {
		   gAF.Execute();		
	    }
	   gAF.GetParamsFromDialog();
	   //alert("Settingsfile: "+Defaultsettingsfile );	
	   //gAF.SaveParamsToDisk( GetDefaultParamsFile() );
           gAF.SaveParamsToDisk( Defaultsettingsfile );
	   //alert("gespeichert");	
	   */
	   
	   preferences.rulerUnits = originalUnit;
	   
   		//app.foregroundColor = org_forecolor;
		//app.backgroundColor = org_backcolor;

   }
   else {
		alert('Kein Photo vorhanden.');
	}

}
// Lot's of things can go wrong
// Give a generic alert and see if they want the details
catch( e ) {
	if ( confirm( 'Da ist was schiefgegangen, sorry.' ) ) {
		alert( e + " : " + e.line );
	}
}


// the main class
function AspectFrame() {

	this.CreateDialog = function() {
	
		// create the main dialog window, this holds all our data

		//	-----------------
		//	|Create a Window|
		//	-----------------
		//                                  dialog means Window [Left,Top,Right,Bottom]
		this.dlgMain = new Window( 'dialog', 'Aspect Frame',[100,100,800,440]);

		// create a shortcut for easier typing
		var input_window = this.dlgMain;

		//
		//
		//	----------------------------
		//	|Add a Aspect Ratio section|
		//	----------------------------
		//                                                panel means Frame
			input_window.aspect_frame = input_window.add('panel',[10,10,500,80],'Seitenverhältnis');
		//
		//	---------------------------------------
		//	|Add Buttons into Aspect Ratio section|
		//	---------------------------------------
		//                                                                radiobutton means Radio Button
			input_window.aspect_frame.r1 = input_window.aspect_frame.add('radiobutton',[ 20,16,120,40],'4:3 (Digital)');
			input_window.aspect_frame.r2 = input_window.aspect_frame.add('radiobutton',[150,16,250,40],'3:2 (Analog)');
			input_window.aspect_frame.r3 = input_window.aspect_frame.add('radiobutton',[300,16,450,40],'unverändert');
			input_window.aspect_frame.r4 = input_window.aspect_frame.add('checkbox',[20,41,450,66],'Schnittlinie erzeugen');

			//input_window.aspect_frame.r3 = input_window.aspect_frame.add('radiobutton',[240,20,340,60],'12:9(DigitalPhoto)');
			//input_window.aspect_frame.r4 = input_window.aspect_frame.add('radiobutton',[350,20,450,60],'18:13(DIA)');
			//input_window.aspect_frame.r5 = input_window.aspect_frame.add('radiobutton',[460,20,560,60],'18:12(Diagial)');
			//input_window.aspect_frame.r6 = input_window.aspect_frame.add('radiobutton',[570,20,670,60],'14:11(14R)');
			//When a button is set to true, it means the button is selected
			input_window.aspect_frame.r1.value = true
		//
		//---------------------------------------------------------------------------------------------------------------
		//
		//	-----------------------------
		//	|Add a Type Of Frame section|
		//	-----------------------------
		//                                              panel means Frame
			input_window.type_frame = input_window.add('panel',[10,90,690,260],'Welche Rahmen');
		//
		//	----------------------------------------
		//	|Add Buttons into Type Of Frame section|
		//	----------------------------------------
		//
			input_window.type_frame.r1 = input_window.type_frame.add('checkbox',[ 20,12,120, 40],'Linie im Foto');
			input_window.type_frame.r2 = input_window.type_frame.add('checkbox',[ 20,42,120, 70],'Linie ums Foto');
			input_window.type_frame.r3 = input_window.type_frame.add('checkbox',[ 20,72,120,100],'Linie aussen');
			input_window.type_frame.r4 = input_window.type_frame.add('checkbox',[ 20,132,120,150],'Rand aussen');
			input_window.type_frame.r1.value = false;
			input_window.type_frame.r2.value = true;
			input_window.type_frame.r3.value = true;
			input_window.type_frame.r4.value = true;

			input_window.type_frame.l1 = input_window.type_frame.add('statictext',[130,16,180,30],'Abstand');
			input_window.type_frame.t1 = input_window.type_frame.add('edittext',[182,14,220,32],'10');

			input_window.type_frame.l3 = input_window.type_frame.add('statictext',[130,76,180,90],'Abstand');
			input_window.type_frame.t3 = input_window.type_frame.add('edittext',[182,74,220,92],'10');

			input_window.type_frame.l4 = input_window.type_frame.add('statictext',[130,136,180,150],'Abstand');
			input_window.type_frame.t4 = input_window.type_frame.add('edittext',[182,134,220,152],'40');


			input_window.type_frame.l1W = input_window.type_frame.add('statictext',[230,16,259,30],'Dicke');
			input_window.type_frame.t1W = input_window.type_frame.add('edittext',[260,14,290,32],'3');

			input_window.type_frame.l2W = input_window.type_frame.add('statictext',[230,46,259,60],'Dicke');
			input_window.type_frame.t2W = input_window.type_frame.add('edittext',[260,44,290,62],'3');

			input_window.type_frame.l3W = input_window.type_frame.add('statictext',[230,76,259,90],'Dicke');
			input_window.type_frame.t3W = input_window.type_frame.add('edittext',[260,74,290,92],'3');


			input_window.type_frame.l1C = input_window.type_frame.add('statictext',[310,16,380,30],'Farbe in HEX');
			input_window.type_frame.t1C = input_window.type_frame.add('edittext',[382,14,440,32],app.foregroundColor.rgb.hexValue);

			input_window.type_frame.l2C = input_window.type_frame.add('statictext',[310,46,380,60],'Farbe in HEX');
			input_window.type_frame.t2C = input_window.type_frame.add('edittext',[382,44,440,62],app.foregroundColor.rgb.hexValue);

			input_window.type_frame.l3C = input_window.type_frame.add('statictext',[310,76,380,90],'Farbe in HEX');
			input_window.type_frame.t3C = input_window.type_frame.add('edittext',[382,74,440,92],app.foregroundColor.rgb.hexValue);

			input_window.type_frame.l4C = input_window.type_frame.add('statictext',[310,136,380,150],'Farbe in HEX');
			input_window.type_frame.t4C = input_window.type_frame.add('edittext',[382,134,440,152],app.backgroundColor.rgb.hexValue);


			input_window.type_frame.r5 = input_window.type_frame.add('checkbox',[ 130,102,300,120],'Innen Passpartout');
			input_window.type_frame.r5.value = false;
			input_window.type_frame.l5C = input_window.type_frame.add('statictext',[310,106,380,120],'Farbe in HEX');
			input_window.type_frame.t5C = input_window.type_frame.add('edittext',[382,104,440,122],app.backgroundColor.rgb.hexValue);


			input_window.type_frame.ColBtns1 = input_window.type_frame.add('panel',[444,8,664,35]);
			input_window.type_frame.ColBtns1.schwarz = input_window.type_frame.ColBtns1.add(colbtn,[10,0,36,26],colbtn1);
			input_window.type_frame.ColBtns1.g64 = input_window.type_frame.ColBtns1.add(colbtn,[40,0,66,26],colbtn2);
			input_window.type_frame.ColBtns1.g128 = input_window.type_frame.ColBtns1.add(colbtn,[70,0,96,26],colbtn3);
			input_window.type_frame.ColBtns1.g192 = input_window.type_frame.ColBtns1.add(colbtn,[100,0,126,26],colbtn4);
			input_window.type_frame.ColBtns1.weiss = input_window.type_frame.ColBtns1.add(colbtn,[130,0,156,26],colbtn5);
			input_window.type_frame.ColBtns1.fore = input_window.type_frame.ColBtns1.add('button',[160,0,186,26],colbtn6);
			input_window.type_frame.ColBtns1.back = input_window.type_frame.ColBtns1.add('button',[190,0,216,26],colbtn7);
			input_window.type_frame.ColBtns1.fore.onClick = function () {input_window.type_frame.t1C.text=app.foregroundColor.rgb.hexValue;};
			input_window.type_frame.ColBtns1.back.onClick = function () {input_window.type_frame.t1C.text=app.backgroundColor.rgb.hexValue;};			
			input_window.type_frame.ColBtns1.schwarz.onClick = function () {input_window.type_frame.t1C.text='000000';};
			input_window.type_frame.ColBtns1.g64.onClick = function () {input_window.type_frame.t1C.text='505050';};
			input_window.type_frame.ColBtns1.g128.onClick = function () {input_window.type_frame.t1C.text='808080';};
			input_window.type_frame.ColBtns1.g192.onClick = function () {input_window.type_frame.t1C.text='C0C0C0';};
			input_window.type_frame.ColBtns1.weiss.onClick = function () {input_window.type_frame.t1C.text='FFFFFF';};

			input_window.type_frame.ColBtns2 = input_window.type_frame.add('panel',[444,38,664,65]);
			input_window.type_frame.ColBtns2.schwarz = input_window.type_frame.ColBtns2.add(colbtn,[10,0,36,26],colbtn1);
			input_window.type_frame.ColBtns2.g64 = input_window.type_frame.ColBtns2.add(colbtn,[40,0,66,26],colbtn2);
			input_window.type_frame.ColBtns2.g128 = input_window.type_frame.ColBtns2.add(colbtn,[70,0,96,26],colbtn3);
			input_window.type_frame.ColBtns2.g192 = input_window.type_frame.ColBtns2.add(colbtn,[100,0,126,26],colbtn4);;
			input_window.type_frame.ColBtns2.weiss = input_window.type_frame.ColBtns2.add(colbtn,[130,0,156,26],colbtn5);
			input_window.type_frame.ColBtns2.fore = input_window.type_frame.ColBtns2.add('button',[160,0,186,26],colbtn6);
			input_window.type_frame.ColBtns2.back = input_window.type_frame.ColBtns2.add('button',[190,0,216,26],colbtn7);
			input_window.type_frame.ColBtns2.fore.onClick = function () {input_window.type_frame.t2C.text=app.foregroundColor.rgb.hexValue;};
			input_window.type_frame.ColBtns2.back.onClick = function () {input_window.type_frame.t2C.text=app.backgroundColor.rgb.hexValue;};			
			input_window.type_frame.ColBtns2.schwarz.onClick = function () {input_window.type_frame.t2C.text='000000';};
			input_window.type_frame.ColBtns2.g64.onClick = function () {input_window.type_frame.t2C.text='505050';};
			input_window.type_frame.ColBtns2.g128.onClick = function () {input_window.type_frame.t2C.text='808080';};
			input_window.type_frame.ColBtns2.g192.onClick = function () {input_window.type_frame.t2C.text='C0C0C0';};
			input_window.type_frame.ColBtns2.weiss.onClick = function () {input_window.type_frame.t2C.text='FFFFFF';};


			input_window.type_frame.ColBtns3 = input_window.type_frame.add('panel',[444,68,664,95]);
			input_window.type_frame.ColBtns3.schwarz = input_window.type_frame.ColBtns3.add(colbtn,[10,0,36,26],colbtn1);
			input_window.type_frame.ColBtns3.g64 = input_window.type_frame.ColBtns3.add(colbtn,[40,0,66,26],colbtn2);
			input_window.type_frame.ColBtns3.g128 = input_window.type_frame.ColBtns3.add(colbtn,[70,0,96,26],colbtn3);
			input_window.type_frame.ColBtns3.g192 = input_window.type_frame.ColBtns3.add(colbtn,[100,0,126,26],colbtn4);;
			input_window.type_frame.ColBtns3.weiss = input_window.type_frame.ColBtns3.add(colbtn,[130,0,156,26],colbtn5);
			input_window.type_frame.ColBtns3.fore = input_window.type_frame.ColBtns3.add('button',[160,0,186,26],colbtn6);
			input_window.type_frame.ColBtns3.back = input_window.type_frame.ColBtns3.add('button',[190,0,216,26],colbtn7);
			input_window.type_frame.ColBtns3.fore.onClick = function () {input_window.type_frame.t3C.text=app.foregroundColor.rgb.hexValue;};
			input_window.type_frame.ColBtns3.back.onClick = function () {input_window.type_frame.t3C.text=app.backgroundColor.rgb.hexValue;};			
			input_window.type_frame.ColBtns3.schwarz.onClick = function () {input_window.type_frame.t3C.text='000000';};
			input_window.type_frame.ColBtns3.g64.onClick = function () {input_window.type_frame.t3C.text='505050';};
			input_window.type_frame.ColBtns3.g128.onClick = function () {input_window.type_frame.t3C.text='808080';};
			input_window.type_frame.ColBtns3.g192.onClick = function () {input_window.type_frame.t3C.text='C0C0C0';};
			input_window.type_frame.ColBtns3.weiss.onClick = function () {input_window.type_frame.t3C.text='FFFFFF';};

			input_window.type_frame.ColBtns5 = input_window.type_frame.add('panel',[444,98,664,125]);
			input_window.type_frame.ColBtns5.schwarz = input_window.type_frame.ColBtns5.add(colbtn,[10,0,36,26],colbtn1);
			input_window.type_frame.ColBtns5.g64 = input_window.type_frame.ColBtns5.add(colbtn,[40,0,66,26],colbtn2);
			input_window.type_frame.ColBtns5.g128 = input_window.type_frame.ColBtns5.add(colbtn,[70,0,96,26],colbtn3);
			input_window.type_frame.ColBtns5.g192 = input_window.type_frame.ColBtns5.add(colbtn,[100,0,126,26],colbtn4);;
			input_window.type_frame.ColBtns5.weiss = input_window.type_frame.ColBtns5.add(colbtn,[130,0,156,26],colbtn5);
			input_window.type_frame.ColBtns5.fore = input_window.type_frame.ColBtns5.add('button',[160,0,186,26],colbtn6);
			input_window.type_frame.ColBtns5.back = input_window.type_frame.ColBtns5.add('button',[190,0,216,26],colbtn7);
			input_window.type_frame.ColBtns5.fore.onClick = function () {input_window.type_frame.t5C.text=app.foregroundColor.rgb.hexValue;};
			input_window.type_frame.ColBtns5.back.onClick = function () {input_window.type_frame.t5C.text=app.backgroundColor.rgb.hexValue;};			
			input_window.type_frame.ColBtns5.schwarz.onClick = function () {input_window.type_frame.t5C.text='000000';};
			input_window.type_frame.ColBtns5.g64.onClick = function () {input_window.type_frame.t5C.text='505050';};
			input_window.type_frame.ColBtns5.g128.onClick = function () {input_window.type_frame.t5C.text='808080';};
			input_window.type_frame.ColBtns5.g192.onClick = function () {input_window.type_frame.t5C.text='C0C0C0';};
			input_window.type_frame.ColBtns5.weiss.onClick = function () {input_window.type_frame.t5C.text='FFFFFF';};

			input_window.type_frame.ColBtns4 = input_window.type_frame.add('panel',[444,128,664,155]);
			input_window.type_frame.ColBtns4.schwarz = input_window.type_frame.ColBtns4.add(colbtn,[10,0,36,26],colbtn1);
			input_window.type_frame.ColBtns4.g64 = input_window.type_frame.ColBtns4.add(colbtn,[40,0,66,26],colbtn2);
			input_window.type_frame.ColBtns4.g128 = input_window.type_frame.ColBtns4.add(colbtn,[70,0,96,26],colbtn3);
			input_window.type_frame.ColBtns4.g192 = input_window.type_frame.ColBtns4.add(colbtn,[100,0,126,26],colbtn4);;
			input_window.type_frame.ColBtns4.weiss = input_window.type_frame.ColBtns4.add(colbtn,[130,0,156,26],colbtn5);
			input_window.type_frame.ColBtns4.fore = input_window.type_frame.ColBtns4.add('button',[160,0,186,26],colbtn6);
			input_window.type_frame.ColBtns4.back = input_window.type_frame.ColBtns4.add('button',[190,0,216,26],colbtn7);
			input_window.type_frame.ColBtns4.fore.onClick = function () {input_window.type_frame.t4C.text=app.foregroundColor.rgb.hexValue;};
			input_window.type_frame.ColBtns4.back.onClick = function () {input_window.type_frame.t4C.text=app.backgroundColor.rgb.hexValue;};			
			input_window.type_frame.ColBtns4.schwarz.onClick = function () {input_window.type_frame.t4C.text='000000';};
			input_window.type_frame.ColBtns4.g64.onClick = function () {input_window.type_frame.t4C.text='505050';};
			input_window.type_frame.ColBtns4.g128.onClick = function () {input_window.type_frame.t4C.text='808080';};
			input_window.type_frame.ColBtns4.g192.onClick = function () {input_window.type_frame.t4C.text='C0C0C0';};
			input_window.type_frame.ColBtns4.weiss.onClick = function () {input_window.type_frame.t4C.text='FFFFFF';};




		//
		//-----------------------------------------------------------------------------------------------------------
		//
		//	------------------------------
		//	|Add a Boundary Width section|
		//	------------------------------
		//                                              
			input_window.f_width = input_window.add('panel',[510,10,690,80],'Aufnahmedatum ausgeben');
		//
		//	--------------------------------
		//	|Add Buttons into Width section|
		//	--------------------------------
		//
			input_window.f_width.c1 = input_window.f_width.add('checkbox',[20,20,178,50],'unten in Textlebene');
			//input_window.f_width.r2 = input_window.f_width.add('radiobutton',[60,20,98,50],'3');
			//input_window.f_width.r3 = input_window.f_width.add('radiobutton',[100,20,138,50],'5');
			//input_window.f_width.r4 = input_window.f_width.add('radiobutton',[140,20,178,50],'7');
			//input_window.f_width.r2.value = true
          input_window.f_width.c1.value = false; //default false

		//
		//-----------------------------------------------------------------------------------------------------------
		//
		//	----------------------
		//	|Add a Colour section|
		//	----------------------
		//                                              
			//input_window.colour = input_window.add('panel',[510,190,690,270],'Farben');
		//
		//	--------------------------------------------
		//	|Add Label And Text Box into Colour section|
		//	--------------------------------------------
		//
			//input_window.colour.l1 = input_window.colour.add('statictext',[20,36,100,56],'Linien in Hex');
			//input_window.colour.t1 = input_window.colour.add('edittext',[110,36,160,56],'FFFFFF');
		//
		//
		//-----------------------------------------------------------------------------------------------------------
		//
		//	--------------------------------
		//	|Add a "Quit" Button to process|
		//	--------------------------------
		//                                            
			input_window.quit = input_window.add('button',[540,300,620,320],'Abbrechen');
		//	------------------------------
		//	|Add a "OK" Button to process|
		//	------------------------------
		//                                            
			input_window.ok = input_window.add('button',[625,300,690,320],'OK');
		//
		//----------------------------------------------------------------------------------------------
		//
			//input_window.message = input_window.add('statictext',[20,285,500,300],'To change Frame Colour and process, enter the value in Hex then Press "Enter"');
		//
		//----------------------------------------------------------------------------------------------
		//

		//	--------------------------------
		//	|Add a "Load"/"SAVE" Buttons to process|
		//	--------------------------------

			input_window.btnLoad = input_window.add('statictext',[20,270,90,290],'Einstellungen ');
			input_window.btnLoad = input_window.add('button',[95,270,150,290],'Laden');
			input_window.btnSave = input_window.add('button',[155,270,220,290],'Speichern');



   /* keine Stapelverarbeitung
		//-------------------------------------------------------------------------
		//
		//	-------------------------------------
		//	|Add a Folder sector into the window|
		//	-------------------------------------
		//                                                panel means Frame
			input_window.folder_frame = input_window.add('panel',[10,250,575,330],'FOLDER');
		//
		//	----------------------------------------------------------
		//	|Add Labels, Text Boxs and Buttons into the Folder sector|
		//	----------------------------------------------------------
		//                                                                statictext means plane text
			input_window.folder_frame.l1 = input_window.folder_frame.add('statictext',[20,20,120,40],'INPUT  FOLDER:');
			input_window.folder_frame.l2 = input_window.folder_frame.add('statictext',[20,50,120,70],'OUTPUT FOLDER:');
		//                                                                edittext means text box
			input_window.folder_frame.t1 = input_window.folder_frame.add('edittext', [130,20,480,40],input_folder.toString());
			input_window.folder_frame.t2 = input_window.folder_frame.add('edittext', [130,50,480,70],output_folder.toString());
		//
			input_window.folder_frame.b1 = input_window.add('button',[510,270,570,290],'Browse');
			input_window.folder_frame.b2 = input_window.add('button',[510,300,570,320],'Browse');
			// Browse the folder
			input_window.folder_frame.b1.onClick = function () {
				input_folder = Folder.selectDialog("Select a folder to process","My Documents");
				input_window.folder_frame.t1.text = input_folder.toString();
			}
			input_window.folder_frame.b2.onClick = function () {
				output_folder = Folder.selectDialog("Select a folder to save","My Documents");
				input_window.folder_frame.t2.text = output_folder.toString();
			}
		//
		//--------------------------------------------------------------------------------------------------------------------------
    */ //ende keine Stapelverarbeitung

		input_window.defaultElement = input_window.ok;
		input_window.cancelElement = input_window.quit;
	}



//***************************
//***Part II -- Processing***
//***************************
//
	// routine for running the dialog and it's interactions
      this.RunDialog = function () {
					//this.dlgMain.btnCancel.onClick = function() { 
					//	var d = FindDialog( this );
					//	d.close( false );

					this.dlgMain.quit.onClick = function () {
					          var d = FindDialog( this );
						    d.close(false);
							};
							
					this.dlgMain.btnLoad.onClick = function() { 
						var d = FindDialog( this );
						var loadFile = null;
						Folder.current = Folder( "~/" );
						if ( File.fs == "Windows" ) {
							loadFile = File.openDialog( strPickXML, strPickXMLWin );
						} else {
							loadFile = File.openDialog( strPickXML, MacXMLFilter );
						}
						if ( loadFile != null ) {
							d.ip.LoadParamsFromDisk( loadFile );
							d.ip.InitDialog();
							d.ip.loadFromDisk = true;
							//d.ip.ForceDialogUpdate();
						}
						d.defaultElement.active = true;
					}
					
					this.dlgMain.btnSave.onClick = function() { 
						var d = FindDialog( this );
						var saveFile = null;
						Folder.current = Folder( "~/" );
						if ( File.fs == "Windows" ) {
							saveFile = File.saveDialog( strPickXMLSave, strPickXMLWin );
						} else {
							saveFile = File.saveDialog( strPickXMLSave, MacXMLFilter );
						}
						if ( saveFile != null ) {
							d.ip.GetParamsFromDialog();
							d.ip.SaveParamsToDisk( saveFile );
						}
						d.defaultElement.active = true;
					}


  			      this.dlgMain.ok.onClick = function () {
						var d = FindDialog( this );
  					   d.ip.MakeFrameAroundPhoto(app.activeDocument,d);

 					   d.close(false);		
  		             return;
					}

				this.InitDialog();

				//this.dlgMain.ForceDialogUpdate();
					
				this.dlgMain.center();
					
				return this.dlgMain.show(); //TM nicht mehr interactiv sondern einfach los
				
			
      }//end of Rundialog

      this.InitParams = function () {
		var params = new Object();
		params["version"] = '1.0';
		params["useopen"] = false;
		/*
		params["folder_frame_t1"] = "";
		params["folder_frame.t2"] = "";*/

       params["out_date"] = false; //default false


		params["aspect_frame_r1"] = true;
		params["aspect_frame_r2"] = false;
		params["aspect_frame_r3"] = false;
		params["aspect_frame_r4"] = true;

		params["type_frame_r1"] = false;
		params["type_frame_r2"] = true;
		params["type_frame_r3"] = true;
		params["type_frame_r4"] = true;
		params["type_frame_r5"] = true;

		params["type_frame_t1"] = "10";
		params["type_frame_t3"] = "10";
		params["type_frame_t4"] = "40";

		params["type_frame_t1W"] = "3";
		params["type_frame_t2W"] = "3";
		params["type_frame_t3W"] = "3";

       params["type_frame_t1C"] = "080808";
       params["type_frame_t2C"] = "080808";
       params["type_frame_t3C"] = "080808";
       params["type_frame_t4C"] = "FFFFFF";
       params["type_frame_t5C"] = "FFFFFF";

		return params;
	}

	// transfer from the dialog widgets to my internal params
	this.GetParamsFromDialog = function() {
		
		var p = this.params;
		var d = this.dlgMain;
		
		//if ( ! this.runningFromBridge ) {
		//	p["useopen"] = d.rbUseOpen.value;
		//	p["source"] = d.sourceLongText;
		//}

		p["version"] = gversion;
		//params["useopen"] = false;
		/*
		p["folder_frame_t1"] = d.folder_frame.t1.text;
		p["folder_frame.t2"] = d.folder_frame.t2.text;
       */
       
       p["out_date"] =  d.f_width.c1.value;
       
		p["aspect_frame_r1"] = d.aspect_frame.r1.value;
		p["aspect_frame_r2"] = d.aspect_frame.r2.value;
		p["aspect_frame_r3"] = d.aspect_frame.r3.value;
		p["aspect_frame_r4"] = d.aspect_frame.r4.value;

		p["type_frame_r1"]   = d.type_frame.r1.value;
		p["type_frame_r2"]   = d.type_frame.r2.value;
		p["type_frame_r3"]   = d.type_frame.r3.value;
		p["type_frame_r4"]   = d.type_frame.r4.value;
		p["type_frame_r5"]   = d.type_frame.r5.value;

		p["type_frame_t1"]   = d.type_frame.t1.text;
		p["type_frame_t3"]   = d.type_frame.t3.text;
		p["type_frame_t4"]   = d.type_frame.t4.text;

		p["type_frame_t1W"]  = d.type_frame.t1W.text;
		p["type_frame_t2W"]  = d.type_frame.t2W.text;
		p["type_frame_t3W"]  = d.type_frame.t3W.text;

       p["type_frame_t1C"]  = d.type_frame.t1C.text;
       p["type_frame_t2C"]  = d.type_frame.t2C.text;
       p["type_frame_t3C"]  = d.type_frame.t3C.text;
       p["type_frame_t4C"]  = d.type_frame.t4C.text;	
       p["type_frame_t5C"]  = d.type_frame.t5C.text;	
	}


	// transfer from the default settings or settings I read off disk to the dialog widgets
	this.InitDialog = function () {

		var d = this.dlgMain;
		var p = this.params;	
		this.dlgMain.ip = this;
		
		//d.loadFromDisk = true;
		
		/*
		d.folder_frame.t1.text =   p["folder_frame_t1"];
		d.folder_frame.t2.text =   p["folder_frame.t2"];
       */
      
		d.f_width.c1.value = p["out_date"]; //default false
       
		d.aspect_frame.r1.value =  p["aspect_frame_r1"];
		d.aspect_frame.r2.value =  p["aspect_frame_r2"];
		d.aspect_frame.r3.value =  p["aspect_frame_r3"];
		d.aspect_frame.r4.value =  p["aspect_frame_r4"];

		d.type_frame.r1.value  =  p["type_frame_r1"]  
		d.type_frame.r2.value  =  p["type_frame_r2"]  
		d.type_frame.r3.value  =  p["type_frame_r3"]  
		d.type_frame.r4.value  =  p["type_frame_r4"]  
		d.type_frame.r5.value  =  p["type_frame_r5"]  

		d.type_frame.t1.text   =  p["type_frame_t1"]  
		d.type_frame.t3.text   =  p["type_frame_t3"]  
		d.type_frame.t4.text   =   p["type_frame_t4"]  

		d.type_frame.t1W.text  =  p["type_frame_t1W"] 
		d.type_frame.t2W.text  =  p["type_frame_t2W"] 
		d.type_frame.t3W.text  =  p["type_frame_t3W"] 

       d.type_frame.t1C.text  =  p["type_frame_t1C"] 
       d.type_frame.t2C.text  =  p["type_frame_t2C"] 
       d.type_frame.t3C.text  =  p["type_frame_t3C"] 
       d.type_frame.t4C.text  =  p["type_frame_t4C"] 
       d.type_frame.t5C.text  =  p["type_frame_t5C"] 
	}


	// load my params from the xml file on disk if it exists
	// this.params["myoptionname"] = myoptionvalue
	// I wrote a very simple xml parser, I'm sure it needs work
      this.LoadParamsFromDisk = function ( loadFile ) {
		if ( loadFile.exists ) {
			loadFile.open( "r" );
			var projectSpace = ReadHeader( loadFile );
			if ( projectSpace == GetScriptNameForXML() ) {
				while ( ! loadFile.eof ) {
					var starter = ReadHeader( loadFile );
					var data = ReadData( loadFile );
					var ender = ReadHeader( loadFile );
					if ( ( "/" + starter ) == ender ) {
						this.params[starter] = data;
					}
					// force boolean values to boolean types
					if ( data == "true" || data == "false" ) {
						this.params[starter] = data == "true";
					}
				}
			}
			loadFile.close();
			if ( this.params["version"] != gversion ) {
				// do something here to fix version conflicts
				// this should do it
				this.params["version"] = gVersion;
			}
		} 
	}


	// save out my params, this is much easier
	this.SaveParamsToDisk = function ( saveFile ) {
		saveFile.encoding = "UTF8";
		saveFile.open( "w", "TEXT", "????" );
		// unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
		saveFile.write("\uFEFF"); 
		var scriptNameForXML = GetScriptNameForXML();
		saveFile.writeln( "<" + scriptNameForXML + ">" );
		for ( var p in this.params ) {
			saveFile.writeln( "\t<" + p + ">" + this.params[p] + "</" + p + ">" );
		}
		saveFile.writeln( "</" + scriptNameForXML + ">" );
		saveFile.close();
	}

	this.ConditionalModeChangeToRGB = function () {
		var eventModeChange = stringIDToTypeID( "8cba8cd6-cb66-11d1-bc43-0060b0a13dc4" );
		var descSource = new ActionDescriptor();
		var keySourceMode = charIDToTypeID( "SrcM" );
		var list = new ActionList();
		var keyCondition = charIDToTypeID( "Cndn" );
		var keyBitmap = charIDToTypeID( "UBtm" );
		var keyGrayscale = charIDToTypeID( "UGry" );
		var keyDuotone = charIDToTypeID( "UDtn" );
		var keyIndex = charIDToTypeID( "UInd" );
		var keyRGB = charIDToTypeID( "URGB" );
		var keyCMYK = charIDToTypeID( "UCMY" );
		var keyLab = charIDToTypeID( "ULab" );
		var keyMultichannel = charIDToTypeID( "UMlt" );
		list.putEnumerated( keyCondition, keyBitmap );
		list.putEnumerated( keyCondition, keyGrayscale );
		list.putEnumerated( keyCondition, keyDuotone );
		list.putEnumerated( keyCondition, keyIndex );
		list.putEnumerated( keyCondition, keyRGB );
		list.putEnumerated( keyCondition, keyCMYK );
		list.putEnumerated( keyCondition, keyLab );
		list.putEnumerated( keyCondition, keyMultichannel );
		descSource.putList( keySourceMode, list );
		var keyDestination = charIDToTypeID( "DstM" );
		var descDest = new ActionDescriptor();
		var keyRGB = charIDToTypeID( "RGBM" );
		descSource.putObject( keyDestination, keyRGB, descDest );
		executeAction( eventModeChange, descSource, DialogModes.NO );
        }

}  // end of function AspectFrame()



//
//----------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------


 function  MakeFrameAroundPhoto (current_picture,params) {

		//var current_picture = app.activeDocument;  //open(fileList[i]);
       //var input_window = FindDialog( this );;

		//
		//	----------------------------
		//	|Setup the opitons selected|
		//	----------------------------
		//	
       var fillcolor = new SolidColor;
      
              //input_window.ip.SaveParamsToDisk( GetDefaultParamsFile() );
              
				// Setup the aspect ratio
				if ( params["aspect_frame_r1"] == true) {
				  ratio_type = 4/3;
				}
				if ( params["aspect_frame_r2"] == true) {
				  ratio_type = 3/2;
				}

				// Setup the frame type
				if ( params["type_frame_r1"] == true) {
					frame_type = "Blank";
				}
				if ( params["type_frame_r2"]  == true) {
					frame_type = "Double";
				}


		      in_width = parseInt(params["type_frame_t1"]);
		      center_width = 0;
		      out_width = parseInt(params["type_frame_t3"]);
		      frame_width = parseInt(params["type_frame_t4"]);

		      strokew1 = parseInt(params["type_frame_t1W"]);
		      strokew2 = parseInt(params["type_frame_t2W"]);
		      strokew3 = parseInt(params["type_frame_t3W"]);

   			   if (params["type_frame_r1"] == false) {
		      		in_width = 0;
		      		strokew1 = 0;
		      }
   			   
   			   if (params["type_frame_r2"] == false) {
   			   		center_width = 0;
		      		strokew2 =0;
		      }

             var showdate = params["out_date"]; //input_window.f_width.c1

		      
   			   if (params["type_frame_r3"] == false) {
		      		out_width = 0;
		      		strokew3 =0;
		      }

             //Korrektur
             //if ((input_window.aspect_frame.r3.value == false)&&(input_window.type_frame.r4.value == false)) {
             if ((params["type_frame_r4"] == false)) {
		         frame_width = 0;
		         //input_window.type_frame.r4.value = true;
		      }



		//	-----------------------------
		//	|Put all files into fileList|
		//	-----------------------------		
		//
		//		var fileList = input_folder.getFiles("*.*");
		//
		//---------------------------------------------------------------
		//
		//	------------------------------------
		//	|Open and Process all files in turn|
		//	------------------------------------		
		//		
			//for (var i = 0; i < fileList.length; i++)
			{
				var vertical_ratio_type = 1/ratio_type;
				// Open files in turn within fileList

		       orgheight=current_picture.height;
		       orgwidth = current_picture.width;


		 //Generate unique 9 digit unit id number using Date
		var d = new Date();
		var i = d.getMilliseconds();
		var unitId = i.toString(10);
		var length = unitId.length;
		unitId.slice(length-9, length);


		// =======================================================
		var id845 = charIDToTypeID( "Mk  " );
		    var desc180 = new ActionDescriptor();
		    var id846 = charIDToTypeID( "null" );
			var ref139 = new ActionReference();
			var id847 = charIDToTypeID( "SnpS" );
			ref139.putClass( id847 );
		    desc180.putReference( id846, ref139 );
		    var id848 = charIDToTypeID( "From" );
			var ref140 = new ActionReference();
			var id849 = charIDToTypeID( "HstS" );
			var id850 = charIDToTypeID( "CrnH" );
			ref140.putProperty( id849, id850 );
		    desc180.putReference( id848, ref140 );
		    var id851 = charIDToTypeID( "Nm  " );
		    desc180.putString( id851, "vor dem Rahmenscript " + unitId);
		    var id852 = charIDToTypeID( "Usng" );
		    var id853 = charIDToTypeID( "HstS" );
		    var id854 = charIDToTypeID( "FllD" );
		    desc180.putEnumerated( id852, id853, id854 );
		executeAction( id845, desc180, DialogModes.NO );


				// Direction of the photo placed
				if ( current_picture.width > current_picture.height) {
					direction = "Horizontal";
		       //   	stroke_width = current_picture.width * 0.005;    			
				}
				if ( current_picture.width < current_picture.height) {
					direction = "Vertical";
				//		stroke_width = current_picture.height * 0.005;    			
				}


		// ==========  New Layer  =================================
		//var id553 = charIDToTypeID( "Mk  " );
		//var desc50 = new ActionDescriptor();
		//var id554 = charIDToTypeID( "null" );
		//var ref6 = new ActionReference();
		//var id555 = charIDToTypeID( "Lyr " );
		//ref6.putClass( id555 );
		//desc50.putReference( id554, ref6 );
		//executeAction( id553, desc50, DialogModes.NO );

				var upperleft, lowerleft,upperright, lowerright;

				var layerRef = current_picture.artLayers.add();
				layerRef.name = 'Rahmenlinien';

				// If type of frame is selected to Double
				// If Double is selected, the following will draw a inner frame into the picture
				if (params["type_frame_r1"] == true) {
					// If the photo is placed horizontally
					if (direction == 'Horizontal') {
						inner_boundary = current_picture.width * 0.005;
					}
					// If the photo is placed vertically
					if (direction == 'Vertical') {
						inner_boundary = current_picture.height * 0.005;
					}
					inner_boundary = in_width;
					// select is a command under selection and is used select an area
					//                                                Upper Left (x,y)                                Lower Left (x,y)                                                 Lower Right (x,y)                                                                       Upper Right (x,y)

					upperleft=new Array(inner_boundary,inner_boundary);
					lowerleft=new Array(inner_boundary,current_picture.height-inner_boundary);
					lowerright=new Array(current_picture.width-inner_boundary,current_picture.height-inner_boundary);
					upperright=new Array(current_picture.width-inner_boundary,inner_boundary);
					current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));

			  stroke_width = strokew1;

					upperleft=new Array(inner_boundary+stroke_width,inner_boundary+stroke_width);
					lowerleft=new Array(inner_boundary+stroke_width,current_picture.height-inner_boundary-stroke_width);
					lowerright=new Array(current_picture.width-inner_boundary-stroke_width,current_picture.height-inner_boundary-stroke_width);
					upperright=new Array(current_picture.width - inner_boundary - stroke_width, inner_boundary + stroke_width);
					current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright),SelectionType.DIMINISH);

					// Fill the selection
			       fillcolor.rgb.hexValue = params["type_frame_t1C"];
					current_picture.selection.fill(fillcolor);
				}; //END if (frame_type == 'Double')

				if (params["type_frame_r2"] == true) {
					// If the photo is placed horizontally
					if (direction == 'Horizontal') {
						inner_boundary = current_picture.width * 0.005;
					}
					// If the photo is placed vertically
					if (direction == 'Vertical') {
						inner_boundary = current_picture.height * 0.005;
					}
					inner_boundary = 0;
					upperleft=new Array(inner_boundary,inner_boundary);
					lowerleft=new Array(inner_boundary,current_picture.height-inner_boundary);
					lowerright=new Array(current_picture.width-inner_boundary,current_picture.height-inner_boundary);
					upperright=new Array(current_picture.width-inner_boundary,inner_boundary);
					current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));

			  stroke_width = strokew2;

					upperleft=new Array(inner_boundary+stroke_width,inner_boundary+stroke_width);
					lowerleft=new Array(inner_boundary+stroke_width,current_picture.height-inner_boundary-stroke_width);
					lowerright=new Array(current_picture.width-inner_boundary-stroke_width,current_picture.height-inner_boundary-stroke_width);
					upperright=new Array(current_picture.width - inner_boundary - stroke_width, inner_boundary + stroke_width);
					current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright),SelectionType.DIMINISH);
					// Fill the selection
			       fillcolor.rgb.hexValue = params["type_frame_t2C"];			
					current_picture.selection.fill(fillcolor);
				}; //END if (frame_type == 'Double')



				if (params["type_frame_r3"] == true) {
					// If the photo is placed horizontally
					if (direction == 'Horizontal') {
						outer_boundary = current_picture.width * 0.02;
					}
					// If the photo is placed vertically
					if (direction == 'Vertical') {
						outer_boundary = current_picture.height * 0.02;
					}
					// select is a command under selection and is used select an area
					//                                                Upper Left (x,y)                                Lower Left (x,y)                                                 Lower Right (x,y)                                                                       Upper Right (x,y)
			  		outer_boundary = out_width*2;
					current_picture.resizeCanvas (current_picture.width + outer_boundary,current_picture.height + outer_boundary,AnchorPosition.MIDDLECENTER);


					upperleft=new Array(0,0);
					lowerleft=new Array(0,current_picture.height);
					lowerright=new Array(current_picture.width,current_picture.height);
					upperright=new Array(current_picture.width,0);
					current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));

			  		stroke_width = strokew3;

					upperleft=new Array(stroke_width,stroke_width);
					lowerleft=new Array(stroke_width,current_picture.height-stroke_width);
					lowerright=new Array(current_picture.width-stroke_width,current_picture.height-stroke_width);
					upperright=new Array(current_picture.width-stroke_width,stroke_width);
					current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright),SelectionType.DIMINISH);

					// Fill the selection
			       fillcolor.rgb.hexValue = params["type_frame_t3C"];						
					current_picture.selection.fill(fillcolor);
				}; //END if (frame_type == 'Double')



		       current_ratio = current_picture.width / current_picture.height;

				if (direction != 'Horizontal') //keine undefinierten Zusatände
					{
                    direction = 'Vertical';
                 }   
                    

		       // Erstmal rand rundrum, wenn gewünscht
				if (params["type_frame_r4"] == true) {
				   //nur Rahmen
						current_picture.resizeCanvas (current_picture.width + frame_width*2, current_picture.height + frame_width*2,AnchorPosition.MIDDLECENTER);
		       }

              current_ratio = current_picture.height / current_picture.width;

                    
				if (direction == 'Vertical') //wo anstückeln
					{
						if (current_ratio < ratio_type) {direction = 'Horizontal';}
                 }
                else 
					{
						if (current_ratio > vertical_ratio_type) {direction = 'Vertical';}
                 }
                    

            // neu nicht so scharf vergleichen
            var AdjustAspect = ( (params["aspect_frame_r3"] != true)&&            
                                 ((current_ratio / vertical_ratio_type > 1.002) || (current_ratio / vertical_ratio_type < 0.99) )&&
                                 ((current_ratio / ratio_type > 1.002) || (current_ratio / ratio_type < 0.99) ) );  

             //alert (AdjustAspect + " AdjustAspect ");                     
             //jetzt den Ausgleich der Ratio
    	     if (AdjustAspect) {					
                       //alert("more canvas:" + AdjustAspect );     

					// If the photo is placed horizontally
					if (direction == 'Vertical') // Bild Breiter machen rechts
					{
						var newwidth = current_picture.height * vertical_ratio_type; ///frame_width;
						
						if (newwidth < current_picture.width)
						{
   					  		newwidth = current_picture.height * ratio_type; ///frame_width;
						}
											
						current_picture.resizeCanvas (newwidth, current_picture.height, AnchorPosition.MIDDLELEFT);

						if (params["aspect_frame_r4"] == true)
						{
							corner = ((frame_width+out_width)*2) + orgwidth;
							upperleft=new Array(corner,    0);
							lowerleft=new Array(corner,    current_picture.height);
							lowerright=new Array(corner+1 ,current_picture.height);
							upperright=new Array(corner+1 ,0);
							current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));
							// Fill the selection				
							fillcolor.rgb.hexValue = '808080';						
							current_picture.selection.fill(fillcolor);
						}
					} // if (direction == 'Horizontal')
					// If the photo is placed vertically						
					else //BILD höher machen unten
					{
						var newheight = current_picture.width * vertical_ratio_type; ///frame_width;
						if (newheight < current_picture.height)
						{
   					  		newheight = current_picture.width * ratio_type; ///frame_width;
						}
						current_picture.resizeCanvas (current_picture.width, newheight,  AnchorPosition.TOPCENTER);

						if (params["aspect_frame_r4"] == true)
						{
							corner = ((frame_width+out_width)*2) + orgheight;
							upperleft=new Array(0, corner);
							lowerleft=new Array(0, corner+1);
							lowerright=new Array(current_picture.width, corner+1);
							upperright=new Array(current_picture.width, corner);
							current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));
							// Fill the selection				
							fillcolor.rgb.hexValue = '808080';						
							current_picture.selection.fill(fillcolor);
						}
					}; // END if (direction == 'Vertical')

				}; // else (direction =Neues Verhältnis)



          // passpartout ausgeben          
          var layerrahemnfarbeNeeded = ( (params["type_frame_r4"] == true) || (AdjustAspect) );
		
		if ( layerrahemnfarbeNeeded ) {
                       //alert("passpartout:" + AdjustAspect + ' # ' + input_window.type_frame.r4.value );     
                       var layerRef2 = current_picture.artLayers.add();
		       layerRef2.name = 'Rahmenfarbe';
		       corner = (frame_width+out_width); 
                       //alert ('corner:'+corner);
				upperleft=new Array(corner, corner);
				lowerleft=new Array(corner, orgheight+corner);
				lowerright=new Array(orgwidth+corner, orgheight+corner);
				upperright=new Array(orgwidth+corner, corner);
				current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));
				current_picture.selection.invert();
				// Fill the selection
			   // Fill the selection
  	          	fillcolor.rgb.hexValue = params["type_frame_t4C"];		
			current_picture.selection.fill(fillcolor);
		}

          // innen passpartout ausgeben
          
          var layerInnenNeeded = ((params["type_frame_r5"] == true) && (out_width>0));
          
		   if ( layerInnenNeeded ) {		   
                       var layerRef2i = current_picture.artLayers.add();
		           layerRef2i.name = 'Rahmenfarbe innen';

                       //alert ('gs: ' + frame_width + ' # ' + out_width);
            
		       corner = (frame_width+out_width+out_width); 
				upperleft=new Array(frame_width, frame_width);
				lowerleft=new Array(frame_width, orgheight+corner);
				lowerright=new Array(orgwidth+corner, orgheight+corner);
				upperright=new Array(orgwidth+corner, frame_width);
				current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright));

                       //alert ('aussen:' + corner + ' # ' + upperleft[0] + ' # ' + upperleft[1]  + ' # ' + lowerright[0] + ' # ' + lowerright[1] );		 
		       corner = (frame_width+out_width); 
				upperleft=new Array(corner,corner);
				lowerleft=new Array(corner, orgheight+corner);
				lowerright=new Array(orgwidth+corner, orgheight+corner);
				upperright=new Array(orgwidth+corner, corner);
				current_picture.selection.select (new Array (upperleft, lowerleft, lowerright, upperright),SelectionType.DIMINISH);

                       //alert ('innen:' + corner + ' # ' + upperleft[0] + ' # ' + upperleft[1] + ' # ' + lowerright[0] + ' # ' + lowerright[1] );		 


				// Fill the selection
		                fillcolor.rgb.hexValue = params["type_frame_t5C"];			
				current_picture.selection.fill(fillcolor);
				}


              if ( showdate ) {
			       corner = (frame_width+out_width); 
	              var toppos = orgheight+corner+out_width;
	              var leftpos = corner + Math.round (orgwidth / 2 );
	 				current_picture.selection.deselect();		
	              CaptionPrint(toppos, leftpos); 
			//bessere Schriftgrösse
	              //WriteStringToLayer('das Datum t17-101-2006');

	              var layerRef3 = current_picture.activeLayer; //layers["Date Created"]
              }
		       var layerSetRef = current_picture.layerSets.add();
		       layerSetRef.name = 'Rahmen(Script)';

              if ( showdate ) {
 				   layerRef3.moveToEnd(layerSetRef);
 				   layerRef3 = null;
 				}   
   	      layerRef.moveToEnd(layerSetRef); 				
 	
 	      if ( layerInnenNeeded ) {
		   layerRef2i.moveToEnd(layerSetRef);
	  	   layerRef2i = null;
 	 	}				

		//alert("am Ende angekommen");				
     	      
     	      if ( layerrahemnfarbeNeeded ) {
     	                  
		   layerRef2.moveToEnd(layerSetRef);
  	           layerRef2 = null;
		 }  

  				
		       layerRef = null;
		       layerSetRef = null;
  		       current_picture = null;


				// Save the file into output folder specified as the same name in Tiff format
				//current_picture.saveAs(new File(output_folder), PSDSaveOptions);
				// Close the current file.picture
				//current_picture.close();
		//alert("am Ende angekommen");				

	//neu keine selection am Ende
        //alert("deselcet und weg")
        app.activeDocument.selection.deselect();


		return;
		

				}; //END for (var i = 0; i < fileList.length; i++)
	}; //END function OK click



// figure out what I call my params file
function GetDefaultParamsFile() {
    return ( new File( app.preferencesfolder + "/" + strTitle + ".xml" ) );
  }



function SaveAsJPEG( inFileName, inQuality, inEmbedICC ) {
	var jpegOptions = new JPEGSaveOptions();
	jpegOptions.quality = inQuality;
	jpegOptions.embedColorProfile = inEmbedICC;
	app.activeDocument.saveAs( File( inFileName ), jpegOptions );
}
	
function SaveAsPSD( inFileName, inMaximizeCompatibility, inEmbedICC ) {
	var psdSaveOptions = new PhotoshopSaveOptions();
    psdSaveOptions.embedColorProfile = inEmbedICC;
    psdSaveOptions.maximizeCompatibility = inMaximizeCompatibility;
	app.activeDocument.saveAs( File( inFileName ), psdSaveOptions );
}
	
function SaveAsTIFF( inFileName, inEmbedICC, inLZW ) {
	var tiffSaveOptions = new TiffSaveOptions();
    tiffSaveOptions.embedColorProfile = inEmbedICC;
    if ( inLZW ) {
		tiffSaveOptions.imageCompression = TIFFEncoding.TIFFLZW;
	} else {
		tiffSaveOptions.imageCompression = TIFFEncoding.NONE;
	}	
	app.activeDocument.saveAs( File( inFileName ), tiffSaveOptions );
}

// use the fit image automation plug-in to do this work for me
function FitImage( inWidth, inHeight ) {
	if ( inWidth == undefined || inHeight == undefined ) {
		alert( strWidthAndHeight );
		return;
	}
	var desc = new ActionDescriptor();
	var unitPixels = charIDToTypeID( '#Pxl' );
	desc.putUnitDouble( charIDToTypeID( 'Wdth' ), unitPixels, inWidth );
	desc.putUnitDouble( charIDToTypeID( 'Hght' ), unitPixels, inHeight );
	var runtimeEventID = stringIDToTypeID( "3caa3434-cb67-11d1-bc43-0060b0a13dc4" );	
	executeAction( runtimeEventID, desc, DialogModes.NO );
}

// a very crude xml parser, this reads the "Tag" of the <Tag>Data</Tag>
function ReadHeader( inFile ) {
	var returnValue = "";
	if ( ! inFile.eof ) {
		var c = "";
		while ( c != "<" && ! inFile.eof ) {
			c = inFile.read( 1 );
		}
		while ( c != ">" && ! inFile.eof ) {
			c = inFile.read( 1 );
			if ( c != ">" ) {
				returnValue += c;
			}
		}
	} else {
		returnValue = "end of file";
	}
	return returnValue;
}

// very crude xml parser, this reads the "Data" of the <Tag>Data</Tag>
function ReadData( inFile ) {
	var returnValue = "";
	if ( ! inFile.eof ) {
		var c = "";
		while ( c != "<" && ! inFile.eof ) {
			c = inFile.read( 1 );
			if ( c != "<" ) {
				returnValue += c;
			}
		}
		inFile.seek( -1, 1 );
	}
	return returnValue;
}

function CheckVersion() {
	var numberArray = version.split(".");
	if ( numberArray[0] < 9 ) {
		alert( strMustUse );
		throw( strMustUse );
	}
}

function CreateUniqueFileName( inFolder, inFileName, inExtension ) {
	inFileName = inFileName.replace(/[:\/\\*\?\"\<\>\|]/g, "_");  // '/\:*?"<>|' -> '_'
	var uniqueFileName = inFolder + inFileName + inExtension;
	var fileNumber = 1;
	while ( File( uniqueFileName ).exists ) {
		uniqueFileName = inFolder + inFileName + "_" + fileNumber + inExtension;
		fileNumber++;
	}
	return uniqueFileName;
}

function CreateShortFileName( inFileName ) {
	if ( inFileName.length > gShortFileNameLength ) {
		return "..." + inFileName.substr( inFileName.length - gShortFileNameLength + 3, gShortFileNameLength - 3 );
	}
	return inFileName;
}

function IsWindowsOS() {
	if ( $.os.search(/windows/i) != -1 ) {
		return true;
	} else {
		return false;
	}
}

function RemoveAlphaChannels() {
	var channels = app.activeDocument.channels;
	var channelCount = channels.length - 1;
	while ( channels[channelCount].kind != ChannelType.COMPONENT ) {
		channels[channelCount].remove();
		channelCount--;
	}
}

function ConvertTosRGBProfile() {
	var id136 = stringIDToTypeID( "convertToProfile" );
    var desc31 = new ActionDescriptor();
    var id137 = charIDToTypeID( "null" );
        var ref6 = new ActionReference();
        var id138 = charIDToTypeID( "Dcmn" );
        var id139 = charIDToTypeID( "Ordn" );
        var id140 = charIDToTypeID( "Trgt" );
        ref6.putEnumerated( id138, id139, id140 );
    desc31.putReference( id137, ref6 );
    var id141 = charIDToTypeID( "T   " );
    desc31.putString( id141, "sRGB IEC61966-2.1" );
    var id142 = charIDToTypeID( "Inte" );
    var id143 = charIDToTypeID( "Inte" );
    var id144 = charIDToTypeID( "Clrm" );
    desc31.putEnumerated( id142, id143, id144 );
    var id145 = charIDToTypeID( "MpBl" );
    desc31.putBoolean( id145, true );
    var id146 = charIDToTypeID( "Dthr" );
    desc31.putBoolean( id146, true );
	executeAction( id136, desc31, DialogModes.NO );
}


// you can't save certain characters in xml, strip them here
// this list is not complete
function GetScriptNameForXML () {
	var scriptNameForXML = new String( strTitle );
	var charsToStrip = Array( " ", "'", "." );
	for (var a = 0; a < charsToStrip.length; a++ )  {
		var nameArray = scriptNameForXML.split( charsToStrip[a] );
		scriptNameForXML = "";
		for ( var b = 0; b < nameArray.length; b++ ) {
			scriptNameForXML += nameArray[b];
		}
	}
	return scriptNameForXML;
}


/////////////////////////////////////////////////////////////////////
// Function: MacXMLFilter
// Input: f, file or folder to check
// Return: true or false, true if file or folder is to be displayed
/////////////////////////////////////////////////////////////////////
function MacXMLFilter( f )
{
	var xmlExtension = ".xml";
	var lCaseName = f.name;
	lCaseName.toLowerCase();
	if ( lCaseName.indexOf( xmlExtension ) == f.name.length - xmlExtension.length )
		return true;
	else if ( f.type == 'TEXT' )
		return true;
	else if ( f instanceof Folder )
		return true;
	else
		return false;
}

// figure out what I call my params file
function GetDefaultParamsFile() {
	return ( new File( app.preferencesFolder + "/" + strTitle + ".xml" ) );
}

function FindDialog( inItem ) {
	var w = inItem;
	while ( 'dialog' != w.type ) {
		if ( undefined == w.parent ) {
			w = null;
			break;
		}
		w = w.parent;
	}
	return w;
}

// Use this to retrieve the current files from the Bridge application
// I don't use it as I run differently only when called from the Bridge
// see photoshop.jsx
function GetFilesFromBridge() {
	var fileList;
	if ( BridgeTalk.isRunning( "bridge" ) ) {
		var bt = new BridgeTalk();
		bt.target = "bridge";
		bt.body = "var theFiles = photoshop.getBridgeFileListForAutomateCommand();theFiles.toSource();";
		bt.onResult = function( inBT ) { fileList = eval( inBT.body ); }
		bt.onError = function( inBT ) { fileList = new Array(); }
		bt.send();
		bt.pump();
		$.sleep( 100 );
		var timeOutAt = ( new Date() ).getTime() + 5000;
		var currentTime = ( new Date() ).getTime();
		while ( ( currentTime < timeOutAt ) && ( undefined == fileList ) ) {
			bt.pump();
			$.sleep( 100 );
			currentTime = ( new Date() ).getTime();
		}
	}
	if ( undefined == fileList ) {
		fileList = new Array();
	}
	return fileList; 
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetActionSetInfo
// Usage: walk all the items in the action palette and record the action set
//        names and all the action children
// Input: <none>
// Return: the array of all the ActionData
// Note: This will throw an error during a normal execution. There is a bug
// in Photoshop that makes it impossible to get an acurate count of the number
// of action sets.
///////////////////////////////////////////////////////////////////////////////
function GetActionSetInfo() {
	var actionSetInfo = new Array();
	var setCounter = 1;
  	while ( true ) {
		var ref = new ActionReference();
		ref.putIndex( gClassActionSet, setCounter );
		var desc = undefined;
		try { desc = executeActionGet( ref ); }
		catch( e ) { break; }
		var actionData = new ActionData();
		if ( desc.hasKey( gKeyName ) ) {
			actionData.name = desc.getString( gKeyName );
		}
		var numberChildren = 0;
		if ( desc.hasKey( gKeyNumberOfChildren ) ) {
			numberChildren = desc.getInteger( gKeyNumberOfChildren );
		}
		if ( numberChildren ) {
			actionData.children = GetActionInfo( setCounter, numberChildren );
			actionSetInfo.push( actionData );
		}
		setCounter++;
	}
	return actionSetInfo;
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetActionInfo
// Usage: used when walking through all the actions in the action set
// Input: action set index, number of actions in this action set
// Return: true or false, true if file or folder is to be displayed
///////////////////////////////////////////////////////////////////////////////
function GetActionInfo( setIndex, numChildren ) {
	var actionInfo = new Array();
	for ( var i = 1; i <= numChildren; i++ ) {
		var ref = new ActionReference();
		ref.putIndex( gClassAction, i );
		ref.putIndex( gClassActionSet, setIndex );
		var desc = undefined;
		desc = executeActionGet( ref );
		var actionData = new ActionData();
		if ( desc.hasKey( gKeyName ) ) {
			actionData.name = desc.getString( gKeyName );
		}
		var numberChildren = 0;
		if ( desc.hasKey( gKeyNumberOfChildren ) ) {
			numberChildren = desc.getInteger( gKeyNumberOfChildren );
		}
		actionInfo.push( actionData );
	}
	return actionInfo;
}


///////////////////////////////////////////////////////////////////////////////
// Function: ActionData
// Usage: this could be an action set or an action
// Input: <none>
// Return: a new Object of ActionData
///////////////////////////////////////////////////////////////////////////////
function ActionData() {
	this.name = "";
	this.children = undefined;
	this.toString = function () {
		var strTemp = this.name;
		if ( undefined != this.children ) {
			for ( var i = 0; i < this.children.length; i++ ) {
				strTemp += " " + this.children[i].toString();
			}
		}
		return strTemp;
	}
}

// we want the current open documents that have a path
// if I do inputFiles = documents then I have a reference
// and if I add documents it also adds them to my inputFiles
// I want to copy the current state
function OpenDocs() {
	var docs = new Array();
	var i = 0;
	var docIndex = 0;
	var alertNonSavedDocs = false;
	var nonSavedDocs = new Array();
	for ( var i = 0; i < app.documents.length; i++ ) {
		try {
			var temp = app.documents[ i ].fullName;
			docs[ docIndex ] = app.documents[ i ];
			docIndex++;
		}
		catch( e ) {
			if ( e.number == 8103 ) { // this document has not been saved
				alertNonSavedDocs = true;
				nonSavedDocs.push( app.documents[ i ].name );
			} else {
				throw e;
			}
		}
	}
	if ( alertNonSavedDocs ) {
		alert( strMustSaveOpen + "\r" + strFollowing + "\r( " + nonSavedDocs + " )" );
	}
	return docs;
}

function ConditionalModeChangeToRGB() {
	var eventModeChange = stringIDToTypeID( "8cba8cd6-cb66-11d1-bc43-0060b0a13dc4" );
	var descSource = new ActionDescriptor();
	var keySourceMode = charIDToTypeID( "SrcM" );
	var list = new ActionList();
	var keyCondition = charIDToTypeID( "Cndn" );
	var keyBitmap = charIDToTypeID( "UBtm" );
	var keyGrayscale = charIDToTypeID( "UGry" );
	var keyDuotone = charIDToTypeID( "UDtn" );
	var keyIndex = charIDToTypeID( "UInd" );
	var keyRGB = charIDToTypeID( "URGB" );
	var keyCMYK = charIDToTypeID( "UCMY" );
	var keyLab = charIDToTypeID( "ULab" );
	var keyMultichannel = charIDToTypeID( "UMlt" );
	list.putEnumerated( keyCondition, keyBitmap );
	list.putEnumerated( keyCondition, keyGrayscale );
	list.putEnumerated( keyCondition, keyDuotone );
	list.putEnumerated( keyCondition, keyIndex );
	list.putEnumerated( keyCondition, keyRGB );
	list.putEnumerated( keyCondition, keyCMYK );
	list.putEnumerated( keyCondition, keyLab );
	list.putEnumerated( keyCondition, keyMultichannel );
	descSource.putList( keySourceMode, list );
	var keyDestination = charIDToTypeID( "DstM" );
	var descDest = new ActionDescriptor();
	var keyRGB = charIDToTypeID( "RGBM" );
	descSource.putObject( keyDestination, keyRGB, descDest );
	executeAction( eventModeChange, descSource, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: AmericanPrettyDate
// Usage: Nobody liked the formatting of the date string 
// Input: inString = date in string format
// Output: convert 2004:01:01 12:00:00 into a Date object
//         or 2004-10-13T10:15:58-08:00
//         If it is not in the above format I return what was passed in
///////////////////////////////////////////////////////////////////////////////
function AmericanPrettyDate( inString ) {
   var gShowTime = true;
	var outString = inString.toString();
	var dateTime = inString.toString().split( ' ' );
	var dateSplit = ':';
	if ( 2 != dateTime.length ) {
		dateTime = inString.toString().split( 'T' );
		if ( 2 != dateTime.length ) return outString;
		dateSplit = "-";
	}
	var dateArray = dateTime[ 0 ].split( dateSplit );
	if ( 3 != dateArray.length ) return outString;
	var timeArray = dateTime[ 1 ].split( ':' );
	if ( timeArray.length < 2 ) return outString;
	var prettyDate = new Date( parseInt( dateArray[ 0 ] ), 
							   parseInt( dateArray[ 1 ] - 1 ), // month is 0 <-> 11
							   parseInt( dateArray[ 2 ] ),
							   parseInt( timeArray[ 0 ] ), 
							   parseInt( timeArray[ 1 ] ), 
							   parseInt( timeArray[ 2 ] ) );
							   
	if ( gShowTime ) {
		outString = prettyDate.toLocaleString();
	} else {
		outString = prettyDate.toLocaleDateString();
	}
	var addComma = outString.split( " " + dateArray[ 2 ] + " " );
	addComma[ 1 ] = ", " + addComma[ 1 ];
	outString = addComma.join( " " + dateArray[ 2 ] );
	return outString;
}

///////////////////////////////////////////////////////////////////////////////
// Function: PrettyDate
// Usage: Nobody liked the formatting of the date string 
// Input: inString = date in string format
// Output: convert 2004:01:01 12:00:00 into a Date object
//         or 2004-10-13T10:15:58-08:00
//         If it is not in the above format I return what was passed in
///////////////////////////////////////////////////////////////////////////////
function PrettyDate( inString ) {
   var gShowTime = true;
	var outString = inString.toString();
	var dateTime = inString.toString().split( ' ' );
	var dateSplit = ':';
	if ( 2 != dateTime.length ) {
		dateTime = inString.toString().split( 'T' );
		if ( 2 != dateTime.length ) return outString;
		dateSplit = "-";
	}
	var dateArray = dateTime[ 0 ].split( dateSplit );
	if ( 3 != dateArray.length ) return outString;
	var timeArray = dateTime[ 1 ].split( ':' );
	if ( timeArray.length < 2 ) return outString;
	var prettyDate = new Date( parseInt( dateArray[ 0 ] ), 
							   parseInt( dateArray[ 1 ] - 1 ), // month is 0 <-> 11
							   parseInt( dateArray[ 2 ] ),
							   parseInt( timeArray[ 0 ] ), 
							   parseInt( timeArray[ 1 ] ), 
							   parseInt( timeArray[ 2 ] ) );
							   
	if ( gShowTime ) {
		outString = prettyDate.toLocaleString();
	} else {
		outString = prettyDate.toLocaleDateString();
	}
	
	var addComma = outString.split( " " + dateArray[ 2 ] + " " );
	addComma[ 1 ] = ", " + addComma[ 1 ];
	outString = addComma.join( " " + dateArray[ 2 ] );
	
   outString = 	dateArray[ 2 ] + '.' +dateArray[ 1 ]  + '.' +dateArray[ 0 ]  + ' ,  ' +timeArray[ 0 ]  + ':' +timeArray[ 1 ] ;
	
	return outString;
}

///////////////////////////////////////////////////////////////////////////////
// Function: MakeSelection
// Usage: easier routine to make a square selection
//        does the array work for you
///////////////////////////////////////////////////////////////////////////////
function MakeSelection( left, top, right, bottom ) {
	var selRegion = Array(Array(left, top),
		                  Array(right, top),
		                  Array(right, bottom),
		                  Array(left, bottom),
				          Array(left, top));

	app.activeDocument.selection.select( selRegion );
}
///////////////////////////////////////////////////////////////////////////////
// Function: GetEXIF
// Usage: Exif comes in pairs, "Mode" and then the string for the Mode
///////////////////////////////////////////////////////////////////////////////
function GetEXIF( inString ) {
	var exifData = app.activeDocument.info.exif;
	for ( var i = 0; i < exifData.length; i++ ) {
		if ( exifData[ i ][ 0 ] == inString ) {
			return exifData[ i ][ 1 ];		
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// Function: GetTextFromIndex
// Usage: Hand back the text or pull it from the metadata
///////////////////////////////////////////////////////////////////////////////
function GetTextFromIndex( p, verbose, index ) {
	var returnValue = '';
	if ( p.checkbox[index] ) {
		if ( p.custom[index] ) {
			returnValue += p.meta[index];
		} else {
			returnValue += GetMetaData( p.meta[index], verbose );
		}
		if ( verbose ) {
			returnValue += gVerboseSeperator;
		}
	}
	return returnValue;
}
///////////////////////////////////////////////////////////////////////////////
// Function: GetMetaData
// Usage: Pull the meta data from the correct spot using the layout 
// in the File Browser "File Properties" "IPTC" "Camera Data (EXIF)" "Camera Raw"
///////////////////////////////////////////////////////////////////////////////
function GetMetaData( inString, verbose ) {
	var lString = inString.toLowerCase();
	var outTitle;
	var outData;
	// "File Properties"
	if ( 'filename' == lString ) {
		outTitle = "Filename";
		outData = app.activeDocument.name;
	} else if ( 'date created' == lString ) {
		outTitle = "Date Created";
		outData = GetXMP( 'xap:CreateDate' );
	} else if ( 'date file modified' == lString ) {
		outTitle = "Date File Modified";
		outData = GetXMP( 'xap:ModifyDate' );
	} else if ( 'image format' == lString ) {
		outTitle = "Image Format";
		outData = GetImageFormat();
	} else if ( 'width' == lString ) {
		outTitle = "Width";
		outData = app.activeDocument.width;
	} else if ( 'height' == lString ) {
		outTitle = "Height";
		outData = app.activeDocument.height;
	} else if ( 'color mode' == lString ) {
		outTitle = "Color Mode";
		outData = ColorModeToString();
	} else if ( 'resolution' == lString ) {
		outTitle = "Resolution";
		outData = app.activeDocument.resolution;
	} else if ( 'color profile' == lString ) {
		outTitle = "Color Profile";
		try {
			outData = app.activeDocument.colorProfileName;
		}
		catch( e ) {
			outData = "Untagged";
		}
	} else if ( 'bit depth' == lString ) {
		outTitle = "Bit Depth";
		outData = app.activeDocument.bitsPerChannel;
	} else if ( 'documentid' == lString ) {
		outTitle = "DocumentID";
		outData = GetXMP( 'xapMM:DocumentID' );
	} else if ( 'document creator' == lString ) {
		outTitle = "Document Creator";
		outData = GetXMP( 'xap:CreatorTool' );
	// "IPTC"
	} else if ( 'description' == lString ) {
		outTitle = "Description";
		outData = app.activeDocument.info.caption;
	} else if ( 'description writer' == lString ) {
		outTitle = "Description Writer";
		outData = app.activeDocument.info.captionWriter;
	} else if ( 'headline' == lString ) {
		outTitle = "Headline";
		outData = app.activeDocument.info.headline;
	} else if ( 'instructions' == lString ) {
		outTitle = "Instructions";
		outData = app.activeDocument.info.instructions;
	} else if ( 'keywords' == lString ) {
		outTitle = "Keywords";
		outData = app.activeDocument.info.keywords;
	} else if ( 'author' == lString ) {
		outTitle = "Author";
		outData = app.activeDocument.info.author;
	} else if ( 'author title' == lString ) {
		outTitle = "Author Title";
		outData = app.activeDocument.info.authorPosition;
	} else if ( 'credit' == lString ) {
		outTitle = "Credit";
		outData = app.activeDocument.info.credit;
	} else if ( 'source' == lString ) {
		outTitle = "Source";
		outData = app.activeDocument.info.source;
	} else if ( 'categories' == lString ) {
		outTitle = "Categories";
		outData = app.activeDocument.info.category;
	} else if ( 'supplemental categories' == lString ) {
		outTitle = "Supplemental Categories";
		outData = app.activeDocument.info.supplementalCategories;
	} else if ( 'document title' == lString ) {
		outTitle = "Document Title";
		outData = app.activeDocument.info.title;
	} else if ( 'date subject created' == lString ) {
		outTitle = "Date Subject Created";
		outData = app.activeDocument.info.creationDate;
	} else if ( 'city' == lString ) {
		outTitle = "City";
		outData = app.activeDocument.info.city;
	} else if ( 'state/province' == lString ) {
		outTitle = "State/Province";
		outData = app.activeDocument.info.provinceState;
	} else if ( 'country' == lString ) {
		outTitle = "Country";
		outData = app.activeDocument.info.country;
	} else if ( 'transmission reference' == lString ) {
		outTitle = "Transmission Reference";
		outData = app.activeDocument.info.transmissionReference;
	} else if ( 'Copyright' == lString ) {
		outTitle = "copyright";
		outData = app.activeDocument.info.copyrightNotice;
	} else if ( 'copyright info url' == lString ) {
		outTitle = "Copyright Info URL";
		outData = app.activeDocument.info.ownerUrl;
	} else if ( 'urgency' == lString ) {
		outTitle = "Urgency";
		outData = UrgencyToString();
	}
	// "EXIF"
	if ( undefined == outTitle ) {
		outData = GetEXIF( inString );
		if ( undefined != outData ) {
			outTitle = inString;
		}
	}
	// "XMP"
	if ( undefined == outTitle ) {
		outData = GetXMP( inString );
		if ( undefined != outData ) {
			outTitle = inString;
		}
	}
	//if ( gUsePrettyDate )
	{
		outData = PrettyDate( outData );
	}
	if ( verbose ) {
		outData = outTitle + ": " + outData;
	}
	return outData;
}


///////////////////////////////////////////////////////////////////////////////
// Function: CaptionPrint
// Usage: Create the caption print output with the given parameters
///////////////////////////////////////////////////////////////////////////////
function CaptionPrint( toppos, leftpos ) {
	// alignment variables
	gAlignBottomEdges = charIDToTypeID( "AdBt" );
	gAlignTopEdges = charIDToTypeID( "AdTp" );
	gAlignLeftEdges = charIDToTypeID( "AdLf" );
	gAlignHorizontalCenters = charIDToTypeID( "AdCH" );
	gAlignRightEdges = charIDToTypeID( "AdRg" );
	gAlignLeft = charIDToTypeID( "Left" );
	gAlignCenter = charIDToTypeID( "Cntr" );
	gAlignRight = charIDToTypeID( "Rght" );
   
   textColor = new SolidColor;
	textColor.rgb.red = 0;
	textColor.rgb.green = 0;
	textColor.rgb.blue = 0;
   
	var fontsize;
 	var gMinFontSize = 6;
  	var gMaxFontSize = 128;
  	var pfont = 'Helvetica';
  	var pfontsize = toppos.value * 0.02; // in pont
  	
  	pfontsize = pfontsize * 72 / app.activeDocument.resolution;
  	
	var fontsize;

   	var itemText = GetMetaData('Date created');
   	var ffaktor = ( toppos.value * 0.001 );
   	if (ffaktor < 1)
   	{
	   	ffaktor = 1;
   	}
	fontSize = pfontsize * ffaktor; //faktor 0,7 1,0 1,5 klein mittel gross

	var hposition = leftpos;
	var vposition = toppos + Math.round (pfontsize*app.activeDocument.resolution / 72) - 5;

	var artLayerRef = app.activeDocument.artLayers.add();
	artLayerRef.name = "Date Created";
	artLayerRef.kind = LayerKind.TEXT;
	// Set the contents of the text layer.
	var textItemRef = artLayerRef.textItem;
	textItemRef.justification = Justification.CENTER;
	textItemRef.position = Array(hposition, vposition);
	textItemRef.contents = itemText; 
	textItemRef.color = textColor;
	textItemRef.size = pfontsize; //in points
	artLayerRef.name = "Date Created";
	//MakeTextBox( itemText, l, top, r, bottom, pfont, fontSize, gAlignCenter, app.activeDocument.width.value, app.activeDocument.height.value, app.activeDocument.resolution );
	//MakeSelection( left, top, right, bottom );
	//AlignEdges( gAlignTopEdges );
	//AlignEdges( gAlignHorizontalCenters );
	app.activeDocument.selection.deselect();
}

///////////////////////////////////////////////////////////////////////////////
// Function: AlignEdges
// Usage: An easy way to cheat to get two layers to lign up
// Input: alignment to use
///////////////////////////////////////////////////////////////////////////////
function AlignEdges( inAlignment ) {
	var id130 = charIDToTypeID( 'Algn' );
    var desc30 = new ActionDescriptor();
    var id131 = charIDToTypeID( 'null' );
        var ref25 = new ActionReference();
        var id132 = charIDToTypeID( 'Lyr ' );
        var id133 = charIDToTypeID( 'Ordn' );
        var id134 = charIDToTypeID( 'Lnkd' );
        ref25.putEnumerated( id132, id133, id134 );
    desc30.putReference( id131, ref25 );
    var id135 = charIDToTypeID( 'Usng' );
    var id136 = charIDToTypeID( 'ADSt' );
    desc30.putEnumerated( id135, id136, inAlignment );
	executeAction( id130, desc30, DialogModes.NO );
}

///////////////////////////////////////////////////////////////////////////////
// Function: GetXMP
// Usage: Search the raw XMP for the given string, sure would be nice to have
//        an actual XML parser
///////////////////////////////////////////////////////////////////////////////
function GetXMP( inString ) {
	var xmp = app.activeDocument.xmpMetadata.rawData;
	var strCombined = '<' + inString + '>';
	var startMarker = xmp.indexOf( strCombined ) + strCombined.length;
	var endMarker = xmp.indexOf( '</' + inString + '>' );
	if ( -1 == endMarker ) return '';
	return xmp.substring( startMarker, endMarker );
}


function WriteStringToLayer( inString ) {

	var aufloesung = app.activeDocument.resolution;
	var dokhoehe = app.activeDocument.height;
	var dokbreite = app.activeDocument.width;
	dokname = app.activeDocument;
	
	if(dokhoehe >= dokbreite) 
		{
		quer = dokhoehe;
		hoch = dokbreite;
		}
	else	{
		quer = dokbreite;
		hoch = dokhoehe;
		}
	hintergrundfarbe = new SolidColor;
	hintergrundfarbe.rgb.red = 0;
	hintergrundfarbe.rgb.green = 0;
	hintergrundfarbe.rgb.blue = 0;
	textfarbe = new SolidColor;
	textfarbe.rgb.red = 96;
	textfarbe.rgb.green = 96;
	textfarbe.rgb.blue = 96;


	//Generieren des Hintergrunds
	//hintergrund = dokname.artLayers.add();
	//hintergrund.name = "EXIF";
	//dokname.resizeCanvas(dokbreite, dokhoehe + hoch * 0.03, AnchorPosition.TOPCENTER);
	//dokname.selection.selectAll();
	//dokname.selection.fill(hintergrundfarbe)
	//dokname.selection.deselect();


	//Hier wird der Text erstellt
	var textgroesse = hoch * 0.02;
	exifebene = dokname.artLayers.add();
	exifebene.kind = LayerKind.TEXT;
	textinhalt = exifebene.textItem;
	textinhalt.justification = Justification.CENTER;
	textinhalt.position = Array(dokbreite/2,dokhoehe - textgroesse - 10)
	textinhalt.color = textfarbe;
	textinhalt.size = textgroesse;
	textinhalt.contents = inString;
}


